from ruamel import yaml
from collections import OrderedDict
from datadog_deployer.monitor import Monitor


class literal_str(str):
    pass


def ordered_dict_representer(dumper, data):
    value = []

    for item_key, item_value in data.items():
        node_key = dumper.represent_data(item_key)
        node_value = dumper.represent_data(item_value)

        value.append((node_key, node_value))

    return yaml.nodes.MappingNode(u'tag:yaml.org,2002:map', value)


def literal_str_representer(dumper, data):
    return dumper.represent_scalar(u'tag:yaml.org,2002:str', data, style='|')


def normalize(monitor: Monitor):
    result = monitor.normalized()
    if 'message' in result:
        result['message'] = literal_str(result['message'])
    return result


def dump(filename):
    yaml.add_representer(OrderedDict, ordered_dict_representer)
    yaml.add_representer(literal_str, literal_str_representer)

    monitors = {
        'monitors': list(map(lambda m: normalize(m), Monitor.read_all()))
    }
    with open(filename, 'w') as stream:
        yaml.dump(monitors, stream=stream, indent=2, default_flow_style=False)
